/*!
 * @file explosion.h
 * @brief a Explosion Projectile
*/

#ifndef _EXPLOSION_H
#define _EXPLOSION_H

#include "world_entity.h"

class SpriteParticles;
class BoxEmitter;
class FastFactory;

class Explosion : public WorldEntity
{
  ObjectListDeclaration(Explosion);
  public:
    static void explode (PNode* position, const Vector& size);

    Explosion ();
    virtual ~Explosion ();

    virtual void activate();
    virtual void deactivate();

    virtual void tick (float time);

    void setLifeTime( float lifeTime ){ this->lifeTime = lifeTime; }

  protected:
    static FastFactory*        fastFactory;

    float                      lifeTime;
    float                      lifeCycle;

    static SpriteParticles*    explosionParticles;
    BoxEmitter*                emitter;
};

#endif /* _EXPLOSION_H */
